
package chatapp.View;

import java.io.IOException;
import java.net.URL;
import java.util.ResourceBundle;

import chatapp.Controller.ChatApp;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Alert;
import javafx.scene.control.Button;
import javafx.scene.control.RadioButton;
import javafx.scene.control.TextField;
import javafx.stage.Stage;
/**
 * <p>
 *     Classe representant l'interface graphique permettant de se connecter.
 *     L'utilisateur rentre un pseudo et choisit une connexion distante ou locale.
 * </p>
 */
public class ConnexionScreen {

    public Button connexionButton;

    public TextField pseudonyme;
    public RadioButton remoteButton;
    public RadioButton localButton;

    @FXML // ResourceBundle that was given to the FXMLLoader
    private ResourceBundle resources;

    @FXML // URL location of the FXML file that was given to the FXMLLoader
    private URL location;

    @FXML // This method is called by the FXMLLoader when initialization is complete
    void initialize() {
        connexionButton.setDefaultButton(true);

    }

    /**
     * <p>
     *     Handler permettant de lancer la connexion avec le pseudonyme contenu dans le TextField pseudonyme en appuyant sur le connexionButton
     * </p>
     * @param actionEvent L'utilisateur vient d'appuyer sur le bouton connexion
     */
    public void connexion(ActionEvent actionEvent) {
        Boolean connexion = false;
        if(this.localButton.isSelected()) {
            // PARTIE CONNEXION LOCALE
            ChatApp.getInstance().setExterne(false);
        }
        else{
            // PARTIE CONNEXION DISTANTE
            ChatApp.getInstance().setExterne(true);
        }
        try {
            connexion = ChatApp.getInstance().connexion(pseudonyme.getText());
        } catch (IOException e) {
            e.printStackTrace();
        }
        if (!connexion) {
            Alert alert = new Alert(Alert.AlertType.INFORMATION);
            alert.setTitle("Connexion");
            // Header Text: null
            alert.setHeaderText(null);
            alert.setContentText("Echec de Connexion: le pseudo " + pseudonyme.getText() + " est deja pris");
            alert.showAndWait();
        } else {
            Stage stage = (Stage) connexionButton.getScene().getWindow();
            Parent root = null;
            try {
                root = FXMLLoader.load(getClass().getResource("/fenetres/View_Menu.fxml"));
            } catch (IOException e) {
                e.printStackTrace();
            }
            Scene scene = new Scene(root);
            stage.setScene(scene);
            stage.show();
        }
    }
}
